<!--
 * Copyright (C) 2022 WYATT GROUP
 * Please see the AUTHORS file for details.

 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
-->

# Dart - Form BLoC

<p align="left">
  <a href="https://git.wyatt-studio.fr/Wyatt-FOSS/wyatt-packages/src/branch/master/packages/wyatt_analysis">
    <img src="https://img.shields.io/badge/Style-Wyatt%20Analysis-blue.svg?style=flat-square" alt="Style: Wyatt Analysis" />
  </a>
  <img src="https://img.shields.io/badge/SDK-Dart%20%7C%20Flutter-blue?style=flat-square" alt="SDK: Dart & Flutter" />
</p>

Form Bloc for Dart & Flutter.

## Features

- Form
    * FormInput: *atom of a form*
        - Store data
        - Validate this data
    * FormEntry: *shell of this atom*
        - Associate a key to an input
        - Configure form attribute (exportation, name...)
    * FormData: *collection of entries*
        - Contain all entries
        - Basic set operation

- FormDataCubit
    * Data management behind a form.
        - Use entries to pass a FormData object
        - You can use several pre configured FormInput for validation
        - You can use updateFormData() to change FormData and validators during runtime (intersection, union, difference or replace)

- Consistent
    * Every class have same naming convention

## Getting started

Simply add `wyatt_form_bloc` in `pubspec.yaml`, then

```dart
import 'package:wyatt_form_bloc/wyatt_form_bloc.dart';
```

## Usage

todo